diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 1f744bec9..b1373963b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2771,9 +2526,8 @@ public class World implements MutableWorldSource {
         }
 
     }
-    
-    public byte[] getChunkData(int x, int y, int z, int xSize, int ySize, int zSize)
-    {
+
+    public byte[] getChunkData(int x, int y, int z, int xSize, int ySize, int zSize) {
         byte[] data = new byte[xSize * ySize * zSize * 8];
         int minChunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
         int minChunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
@@ -2782,125 +2536,104 @@ public class World implements MutableWorldSource {
         int startIndex = 0;
         int minY = y;
         int maxY = y + ySize;
-        if(minY < 0)
-        {
+        if (minY < 0) {
             minY = 0;
         }
-        if(maxY > getHeightBlocks())
-        {
+        if (maxY > getHeightBlocks()) {
             maxY = getHeightBlocks();
         }
-        for(int chunkX = minChunkX; chunkX <= maxChunkX; chunkX++)
-        {
+        for (int chunkX = minChunkX; chunkX <= maxChunkX; chunkX++) {
             int minX = x - chunkX * Chunk.CHUNK_SIZE_X;
             int maxX = (x + xSize) - chunkX * Chunk.CHUNK_SIZE_X;
-            if(minX < 0)
-            {
+            if (minX < 0) {
                 minX = 0;
             }
-            if(maxX > Chunk.CHUNK_SIZE_X)
-            {
+            if (maxX > Chunk.CHUNK_SIZE_X) {
                 maxX = Chunk.CHUNK_SIZE_X;
             }
-            for(int chunkZ = minChunkZ; chunkZ <= maxChunkZ; chunkZ++)
-            {
+            for (int chunkZ = minChunkZ; chunkZ <= maxChunkZ; chunkZ++) {
                 int minZ = z - chunkZ * Chunk.CHUNK_SIZE_Z;
                 int maxZ = (z + zSize) - chunkZ * Chunk.CHUNK_SIZE_Z;
-                if(minZ < 0)
-                {
+                if (minZ < 0) {
                     minZ = 0;
                 }
-                if(maxZ > Chunk.CHUNK_SIZE_Z)
-                {
+                if (maxZ > Chunk.CHUNK_SIZE_Z) {
                     maxZ = Chunk.CHUNK_SIZE_Z;
                 }
                 startIndex = getChunkFromChunkCoords(chunkX, chunkZ).getChunkData(data, minX, minY, minZ, maxX, maxY, maxZ, startIndex);
             }
 
         }
-        
+
         return data;
     }
 
-    public void sendQuittingDisconnectingPacket()
-    {
+    public void sendQuittingDisconnectingPacket() {
     }
 
-    public void checkSessionLock()
-    {
-        saveHandler.checkSessionLock();
+    public void checkSessionLock() {
+        this.saveHandler.checkSessionLock();
     }
 
-    public void setWorldTime(long l)
-    {
-        levelData.setWorldTime(l);
+    public void setWorldTime(long l) {
+        this.levelData.setWorldTime(l);
     }
-    
+
     public void setWorldTimeUpdateTicks(final long ticks) {
-        final long currentTime = this.levelData.getWorldTime();
-        final long newTime = ticks;
+        final long delta = ticks - this.levelData.getWorldTime();
 
-        for (final @NotNull NextTickListEntry entry : this.tickNextTickList) {
-            final long ticksRemaining = entry.getEndTime() - currentTime;
-            entry.creationTime = newTime;
-            entry.delay = ticksRemaining;
+        for (final @NotNull NextTickListEntry entry : this.tickNextTickSet) {
+            entry.delay += delta;
         }
 
         this.setWorldTime(ticks);
     }
 
-    public long getRandomSeed()
-    {
-        return levelData.getRandomSeed();
+    public long getRandomSeed() {
+        return this.levelData.getRandomSeed();
     }
 
-    public long getWorldTime()
-    {
-        return levelData.getWorldTime();
+    public long getWorldTime() {
+        return this.levelData.getWorldTime();
     }
 
     public Difficulty getDifficulty() {
-        return levelData.getDifficulty();
+        return this.levelData.getDifficulty();
     }
 
     public void setDifficulty(Difficulty difficulty, boolean overrideLock) {
-        levelData.setDifficulty(difficulty, overrideLock);
+        this.levelData.setDifficulty(difficulty, overrideLock);
     }
+
     public void setDifficulty(int difficulty, boolean overrideLock) {
-        levelData.setDifficulty(difficulty, overrideLock);
+        this.levelData.setDifficulty(difficulty, overrideLock);
     }
 
-    public TilePos getSpawnPoint()
-    {
-        return new TilePos(levelData.getSpawnX(), levelData.getSpawnY(), levelData.getSpawnZ());
+    public @NotNull TilePos getSpawnPoint() {
+        return new TilePos(this.levelData.getSpawnX(), this.levelData.getSpawnY(), this.levelData.getSpawnZ());
     }
 
-    public void setSpawnPoint(ChunkCoordinates chunkcoordinates)
-    {
-        levelData.setSpawn(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z);
+    public void setSpawnPoint(ChunkCoordinates chunkcoordinates) {
+        this.levelData.setSpawn(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z);
     }
 
-    public void joinEntityInSurroundings(Entity entity)
-    {
+    public void joinEntityInSurroundings(Entity entity) {
         int i = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
         int j = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
         byte byte0 = 2;
-        for(int k = i - byte0; k <= i + byte0; k++)
-        {
-            for(int l = j - byte0; l <= j + byte0; l++)
-            {
+        for (int k = i - byte0; k <= i + byte0; k++) {
+            for (int l = j - byte0; l <= j + byte0; l++) {
                 getChunkFromChunkCoords(k, l);
             }
 
         }
 
-        if(!entities.contains(entity))
-        {
-            entities.add(entity);
+        if (!this.entities.contains(entity)) {
+            this.entities.add(entity);
         }
     }
 
-    public boolean canMineBlock(final @NotNull Player player, final @NotNull TilePos tilePos) {
+    public boolean canMineBlock(final @NotNull Player player, final @NotNull TilePosc tilePos) {
         return true;
     }
 
@@ -2909,75 +2642,63 @@ public class World implements MutableWorldSource {
         return this.canMineBlock(player, new TilePos(x, y, z));
     }
 
-    public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus)
-    {
+    public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus) {
     }
 
-    public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus, float attackedAtYaw)
-    {
+    public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus, float attackedAtYaw) {
     }
 
     public void sendTrackedEntityDataPacket(Entity entity) {
 
     }
 
-    public void updateEntityList()
-    {
-        entities.removeAll(entitiesToRemove);
-        for(int i = 0; i < entitiesToRemove.size(); i++)
-        {
-            Entity entity = entitiesToRemove.get(i);
+    public void updateEntityList() {
+        this.entities.removeAll(this.entitiesToRemove);
+        for (int i = 0; i < this.entitiesToRemove.size(); i++) {
+            Entity entity = this.entitiesToRemove.get(i);
             int cX = entity.chunkCoordX;
             int cZ = entity.chunkCoordZ;
-            if(entity.addedToChunk && isChunkLoaded(cX, cZ))
-            {
+            if (entity.addedToChunk && isChunkLoaded(cX, cZ)) {
                 getChunkFromChunkCoords(cX, cZ).removeEntity(entity);
             }
         }
 
-        for(int j = 0; j < entitiesToRemove.size(); j++)
-        {
-            releaseEntitySkin(entitiesToRemove.get(j));
+        for (int j = 0; j < this.entitiesToRemove.size(); j++) {
+            releaseEntitySkin(this.entitiesToRemove.get(j));
         }
 
-        entitiesToRemove.clear();
-        for(int i = 0; i < entities.size(); i++)
-        {
-            Entity entity = entities.get(i);
-            if(entity.vehicle != null)
-            {
-                if(!entity.vehicle.isRemoved() && entity.vehicle.getPassenger() == entity)
-                {
+        this.entitiesToRemove.clear();
+        for (int i = 0; i < this.entities.size(); i++) {
+            Entity entity = this.entities.get(i);
+            if (entity.vehicle != null) {
+                if (!entity.vehicle.isRemoved() && entity.vehicle.getPassenger() == entity) {
                     continue;
                 }
                 entity.vehicle.setPassenger(null);
                 entity.vehicle = null;
             }
-            if(!entity.removed)
-            {
+            if (!entity.removed) {
                 continue;
             }
             int cX = entity.chunkCoordX;
             int cZ = entity.chunkCoordZ;
-            if(entity.addedToChunk && isChunkLoaded(cX, cZ))
-            {
+            if (entity.addedToChunk && isChunkLoaded(cX, cZ)) {
                 getChunkFromChunkCoords(cX, cZ).removeEntity(entity);
             }
-            entities.remove(i--);
+            this.entities.remove(i--);
             releaseEntitySkin(entity);
         }
 
     }
 
-    public IChunkProvider getChunkProvider()
-    {
-        return chunkProvider;
+    public IChunkProvider getChunkProvider() {
+        return this.chunkProvider;
     }
 
-    public void triggerEvent(final @NotNull TilePos tilePos, final int index, final int data) {
+    public void triggerEvent(final @NotNull TilePosc tilePos, final int index, final int data) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         if (block != null) {
-            block.triggerEvent(this, tilePos.x, tilePos.y, tilePos.z, index, data);
+            block.triggerEvent(this, tilePos.x(), tilePos.y(), tilePos.z(), index, data);
         }
     }
 
@@ -2985,69 +2706,61 @@ public class World implements MutableWorldSource {
     public final void triggerEvent(final int x, final int y, final int z, final int index, final int data) {
         this.triggerEvent(new TilePos(x, y, z), index, data);
     }
-    
-    public LevelStorage getSaveHandler()
-    {
-        return saveHandler;
+
+    public LevelStorage getSaveHandler() {
+        return this.saveHandler;
     }
 
-    public LevelData getLevelData()
-    {
-        return levelData;
+    public LevelData getLevelData() {
+        return this.levelData;
     }
 
-    public void updateEnoughPlayersSleepingFlag(Player player)
-    {
-        enoughPlayersSleeping = false;
-        if(!players.isEmpty()) {
+    public void updateEnoughPlayersSleepingFlag(Player player) {
+        this.enoughPlayersSleeping = false;
+        if (!this.players.isEmpty()) {
             int playersSleeping = 0;
             int req = getPlayersRequiredToSkipNight();
-            for(Player p : players)
-                if(p.isPlayerSleeping()) playersSleeping++;
-            if(playersSleeping >= req) {
-                enoughPlayersSleeping = true;
+            for (Player p : this.players)
+                if (p.isPlayerSleeping()) playersSleeping++;
+            if (playersSleeping >= req) {
+                this.enoughPlayersSleeping = true;
             }
         }
     }
-    
-    public int getPlayersRequiredToSkipNight()
-    {
-        return (int) (players.size() * (sleepPercent / 100.0));
+
+    public int getPlayersRequiredToSkipNight() {
+        return (int) (this.players.size() * (this.sleepPercent / 100.0));
     }
 
-    protected void wakeUpAllPlayers()
-    {
-        enoughPlayersSleeping = false;
-        for (Player entityplayer : players) {
+    protected void wakeUpAllPlayers() {
+        this.enoughPlayersSleeping = false;
+        for (Player entityplayer : this.players) {
             if (entityplayer.isPlayerSleeping()) {
                 entityplayer.wakeUpPlayer(false, false);
             }
         }
         final @Nullable Weather currentWeather = getCurrentWeather();
-        if (currentWeather instanceof IPrecipitation && ((IPrecipitation) currentWeather).spawnRainParticles())
-        {
-            weatherManager.overrideWeather(worldType.getDefaultWeather());
+        if (currentWeather instanceof IPrecipitation && ((IPrecipitation) currentWeather).spawnRainParticles()) {
+            this.weatherManager.overrideWeather(this.worldType.getDefaultWeather());
         }
     }
 
-    public boolean areEnoughPlayersFullyAsleep()
-    {
-        if(enoughPlayersSleeping && !isClientSide)
-        {
+    public boolean areEnoughPlayersFullyAsleep() {
+        if (this.enoughPlayersSleeping && !this.isClientSide) {
             int fullyAsleep = 0;
-            for(Player player : players) if(player.isPlayerFullyAsleep()) fullyAsleep++;
+            for (Player player : this.players) if (player.isPlayerFullyAsleep()) fullyAsleep++;
             return fullyAsleep >= getPlayersRequiredToSkipNight() && fullyAsleep > 0;
         } else {
             return false;
         }
     }
 
-    public boolean isBlockBeingRainedOn(final @NotNull TilePos tilePos) {
+    public boolean isBlockBeingRainedOn(final @NotNull TilePosc tilePos) {
         if (
             this.getCurrentWeather() == null ||
-            !(this.getCurrentWeather() instanceof IPrecipitation) ||
-            !this.canBlockSeeSky(tilePos) ||
-            this.getHeightValue(tilePos.x, tilePos.z) > tilePos.y
+                !(this.getCurrentWeather() instanceof IPrecipitation) ||
+                !this.canBlockSeeSky(tilePos) ||
+                this.getHeightValue(tilePos.x(), tilePos.z()) > tilePos.y()
         ) {
             return false;
         }
@@ -3067,22 +2780,19 @@ public class World implements MutableWorldSource {
         return this.isBlockBeingRainedOn(new TilePos(x, y, z));
     }
 
-    public void setSavedData(String id, SavedData savedData)
-    {
-        savedDataStorage.set(id, savedData);
+    public void setSavedData(String id, SavedData savedData) {
+        this.savedDataStorage.set(id, savedData);
     }
 
-    public SavedData getSavedData(Class<? extends SavedData> saveDataClass, String id)
-    {
-        return savedDataStorage.load(saveDataClass, id);
+    public SavedData getSavedData(Class<? extends SavedData> saveDataClass, String id) {
+        return this.savedDataStorage.load(saveDataClass, id);
     }
 
-    public int getUniqueDataId(String s)
-    {
-        return savedDataStorage.getFreeMetadataFor(s);
+    public int getUniqueDataId(String s) {
+        return this.savedDataStorage.getFreeMetadataFor(s);
     }
 
-    public void playBlockEvent(final @NotNull TilePos tilePos, final int id, final int data) {
+    public void playBlockEvent(final @NotNull TilePosc tilePos, final int id, final int data) {
         this.playBlockEvent(null, tilePos, id, data);
     }
 
@@ -3091,9 +2801,9 @@ public class World implements MutableWorldSource {
         this.playBlockEvent(new TilePos(x, y, z), id, data);
     }
 
-    public void playBlockEvent(final @Nullable Player player, final @NotNull TilePos tilePos, final int id, final int data) {
+    public void playBlockEvent(final @Nullable Player player, final @NotNull TilePosc tilePos, final int id, final int data) {
         for (final @NotNull LevelListener listener : this.listeners) {
-            listener.levelEvent(player, id, tilePos.x, tilePos.y, tilePos.z, data);
+            listener.levelEvent(player, id, tilePos.x(), tilePos.y(), tilePos.z(), data);
         }
     }
 
@@ -3101,19 +2811,18 @@ public class World implements MutableWorldSource {
     public final void playBlockEvent(final @Nullable Player player, final int id, final int x, final int y, final int z, final int data) {
         this.playBlockEvent(player, new TilePos(x, y, z), id, data);
     }
-    
-    public @NotNull WorldType getWorldType()
-    {
-        return worldType;
+
+    public @NotNull WorldType getWorldType() {
+        return this.worldType;
     }
 
-    public @NotNull EntityItem dropItem(final @NotNull TilePos tilePos, final @NotNull ItemStack itemStack) {
+    public @NotNull EntityItem dropItem(final @NotNull TilePosc tilePos, final @NotNull ItemStack itemStack) {
         final float radius = 0.7f;
         final double x = (this.rand.nextFloat() * radius) + (1.0F - radius) * 0.5D;
         final double y = (this.rand.nextFloat() * radius) + (1.0F - radius) * 0.5D;
         final double z = (this.rand.nextFloat() * radius) + (1.0F - radius) * 0.5D;
 
-        final @NotNull EntityItem item = new EntityItem(this, tilePos.x + x, tilePos.y + y, tilePos.z + z, itemStack);
+        final @NotNull EntityItem item = new EntityItem(this, tilePos.x() + x, tilePos.y() + y, tilePos.z() + z, itemStack);
         item.pickupDelay = 10;
         this.entityJoinedWorld(item);
         return item;
@@ -3124,8 +2833,8 @@ public class World implements MutableWorldSource {
         return this.dropItem(new TilePos(x, y, z), itemStack);
     }
 
-    public void sendGlobalMessage(String message){
-        for (Player player : players){
+    public void sendGlobalMessage(String message) {
+        for (Player player : this.players) {
             player.sendMessage(message);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
index 67969e846..3294d86ed 100644
--- a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.SeasonManager;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -14,28 +15,28 @@ import org.jetbrains.annotations.Nullable;
 public interface WorldSource {
     int getHeightBlocks();
 
-    int getBlockId(final @NotNull TilePos tilePos);
+    int getBlockId(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default int getBlockId(final int x, final int y, final int z) {
         return this.getBlockId(new TilePos(x, y, z));
     }
 
-    @Nullable Block<?> getBlock(final @NotNull TilePos tilePos);
+    @Nullable Block<?> getBlock(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default @Nullable Block<?> getBlock(final int x, final int y, final int z) {
         return this.getBlock(new TilePos(x, y, z));
     }
 
-    @Nullable TileEntity getTileEntity(final @NotNull TilePos tilePos);
+    @Nullable TileEntity getTileEntity(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default @Nullable TileEntity getTileEntity(final int x, final int y, final int z) {
         return this.getTileEntity(new TilePos(x, y, z));
     }
 
-    default <T> @Nullable T getBlockLogic(final @NotNull TilePos tilePos, final @NotNull Class<T> logicClass) {
+    default <T> @Nullable T getBlockLogic(final @NotNull TilePosc tilePos, final @NotNull Class<T> logicClass) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         if (block == null) {
             return null;
@@ -54,14 +55,14 @@ public interface WorldSource {
         return this.getBlockLogic(new TilePos(x, y, z), logicClass);
     }
 
-    float getBrightness(final @NotNull TilePos tilePos, final int lightEmission);
+    float getBrightness(final @NotNull TilePosc tilePos, final int lightEmission);
 
     @Deprecated
     default float getBrightness(final int x, final int y, final int z, final int lightEmission) {
         return this.getBrightness(new TilePos(x, y, z), lightEmission);
     }
 
-    int getLightmapCoord(final @NotNull TilePos tilePos, final int lightEmission);
+    int getLightmapCoord(final @NotNull TilePosc tilePos, final int lightEmission);
 
     @Deprecated
     default int getLightmapCoord(final int x, final int y, final int z, final int lightEmission) {
@@ -70,56 +71,56 @@ public interface WorldSource {
 
     int getLightmapCoord(int skyLight, int blockLight);
 
-    float getLightBrightness(final @NotNull TilePos tilePos);
+    float getLightBrightness(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default float getLightBrightness(final int x, final int y, final int z) {
         return this.getLightBrightness(new TilePos(x, y, z));
     }
 
-    int getBlockData(final @NotNull TilePos tilePos);
+    int getBlockData(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default int getBlockMetadata(final int x, final int y, final int z) {
         return this.getBlockData(new TilePos(x, y, z));
     }
 
-    @NotNull Material getBlockMaterial(final @NotNull TilePos tilePos);
+    @NotNull Material getBlockMaterial(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default @NotNull Material getBlockMaterial(final int x, final int y, final int z) {
         return this.getBlockMaterial(new TilePos(x, y, z));
     }
 
-    boolean isBlockOpaqueCube(final @NotNull TilePos tilePos);
+    boolean isBlockOpaqueCube(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default boolean isBlockOpaqueCube(final int x, final int y, final int z) {
         return this.isBlockOpaqueCube(new TilePos(x, y, z));
     }
 
-    boolean isBlockNormalCube(final @NotNull TilePos tilePos);
+    boolean isBlockNormalCube(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default boolean isBlockNormalCube(final int x, final int y, final int z) {
         return this.isBlockNormalCube(new TilePos(x, y, z));
     }
 
-    double getBlockTemperature(final @NotNull TilePos tilePos);
+    double getBlockTemperature(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default double getBlockTemperature(final int x, final int z) {
         return this.getBlockTemperature(new TilePos(x, 0, z));
     }
 
-    double getBlockHumidity(final @NotNull TilePos tilePos);
+    double getBlockHumidity(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default double getBlockHumidity(final int x, final int z) {
         return this.getBlockHumidity(new TilePos(x, 0, z));
     }
 
-    double getBlockVariety(final @NotNull TilePos tilePos);
+    double getBlockVariety(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default double getBlockVariety(final int x, final int z) {
@@ -128,14 +129,14 @@ public interface WorldSource {
 
     @NotNull SeasonManager getSeasonManager();
 
-    @NotNull Biome getBlockBiome(final @NotNull TilePos tilePos);
+    @NotNull Biome getBlockBiome(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default @Nullable Biome getBlockBiome(final int x, final int y, final int z) {
         return this.getBlockBiome(new TilePos(x, y, z));
     }
 
-    int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos);
+    int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default int getSavedLightValue(final @NotNull LightLayer layer, final int x, final int y, final int z) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
index 821817428..ad5ca9ffa 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -15,6 +15,7 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.weather.Weather;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -27,10 +28,10 @@ public class Biome
     public short topBlock;
     public short fillerBlock;
     public Weather[] blockedWeathers = new Weather[0];
-    protected List<SpawnListEntry> spawnableMonsterList;
-    protected List<SpawnListEntry> spawnableCreatureList;
-    protected List<SpawnListEntry> spawnableWaterCreatureList;
-    protected List<SpawnListEntry> spawnableAmbientCreatureList;
+    protected @NotNull List<@NotNull SpawnListEntry> spawnableMonsterList = new ArrayList<>();
+    protected @NotNull List<@NotNull SpawnListEntry> spawnableCreatureList = new ArrayList<>();
+    protected @NotNull List<@NotNull SpawnListEntry> spawnableWaterCreatureList = new ArrayList<>();
+    protected @NotNull List<@NotNull SpawnListEntry> spawnableAmbientCreatureList = new ArrayList<>();
     private boolean hasSurfaceSnow = false;
     
     public Biome(String key)
@@ -38,10 +39,6 @@ public class Biome
     	this.translationKey = "biome." + key; 
         topBlock = (short) Blocks.GRASS.id();
         fillerBlock = (short)Blocks.DIRT.id();
-        spawnableMonsterList = new ArrayList<>();
-        spawnableCreatureList = new ArrayList<>();
-        spawnableWaterCreatureList = new ArrayList<>();
-        spawnableAmbientCreatureList = new ArrayList<>();
         spawnableMonsterList.add(new SpawnListEntry(MobSpider.class, 10));
         spawnableMonsterList.add(new SpawnListEntry(MobZombie.class, 10));
         spawnableMonsterList.add(new SpawnListEntry(MobZombieArmored.class, 2));
@@ -90,20 +87,14 @@ public class Biome
         return java.awt.Color.getHSBColor(0.6222222F - temperature * 0.125F, 0.5F + temperature * 0.1F, 1.0F).getRGB();
     }
 
-    public List<SpawnListEntry> getSpawnableList(MobCategory creatureType)
+    public @NotNull List<@NotNull SpawnListEntry> getSpawnableList(final @NotNull MobCategory creatureType)
     {
-        switch (creatureType){
-            case monster:
-                return spawnableMonsterList;
-            case creature:
-                return spawnableCreatureList;
-            case waterCreature:
-                return spawnableWaterCreatureList;
-            case ambientCreature:
-                return spawnableAmbientCreatureList;
-            default:
-                return null;
-        }
+        return switch (creatureType) {
+            case MONSTER -> spawnableMonsterList;
+            case CREATURE -> spawnableCreatureList;
+            case WATER_CREATURE -> spawnableWaterCreatureList;
+            case AMBIENT -> spawnableAmbientCreatureList;
+        };
     }
     
     public boolean hasSurfaceSnow()
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java
index ef6d83e51..42d548ae5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java
@@ -7,42 +7,36 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.world.biome.Biome;
 import org.slf4j.Logger;
 
-public abstract class BiomeProvider
-{
+public abstract class BiomeProvider {
     private static final Logger LOGGER = LogUtils.getLogger();
-    public Biome getBiome(final int x, final int y, final int z)
-    {
+
+    public Biome getBiome(final int x, final int y, final int z) {
         final Biome[] out = getBiomes(null, x, y, z, 1, 1, 1);
         return out[0];
     }
 
-    public double getTemperature(final int x, final int z)
-    {
+    public double getTemperature(final int x, final int z) {
         final double[] out = getTemperatures(null, x, z, 1, 1);
         return out[0];
     }
 
-    public double getHumidity(final int x, final int z)
-    {
+    public double getHumidity(final int x, final int z) {
         final double[] out = getHumidities(null, x, z, 1, 1);
         return out[0];
     }
 
-    public double getVariety(final int x, final int z)
-    {
+    public double getVariety(final int x, final int z) {
         final double[] out = getVarieties(null, x, z, 1, 1);
         return out[0];
     }
 
 
-    public double getBiomeness(final int x, final int y, final int z)
-    {
+    public double getBiomeness(final int x, final int y, final int z) {
         final double[] out = getBiomenesses(null, x, y, z, 1, 1, 1);
         return out[0];
     }
 
-    public Biome[] getBiomes(final Biome[] biomes, final int x, final int y, final int z, final int xSize, final int ySize, final int zSize)
-    {
+    public Biome[] getBiomes(final Biome[] biomes, final int x, final int y, final int z, final int xSize, final int ySize, final int zSize) {
         return getBiomes(biomes, null, null, null, x, y, z, xSize, ySize, zSize);
     }
 
@@ -51,14 +45,14 @@ public abstract class BiomeProvider
     public abstract double[] getTemperatures(double[] temperatures, int x, int z, int xSize, int zSize);
 
     public abstract double[] getHumidities(double[] humidities, int x, int z, int xSize, int zSize);
+
     public abstract double[] getVarieties(double[] varieties, int x, int z, int xSize, int zSize);
 
     public abstract double[] getBiomenesses(double[] biomenesses, int x, int y, int z, int xSize, int ySize, int zSize);
 
     public abstract Biome lookupBiome(double temperature, double humidity, double altitude, double variety);
 
-    protected void generateBiomeDistributionStats()
-    {
+    protected void generateBiomeDistributionStats() {
         int lastReport = 0;
         final int sizeChunks = 2048;
         int chunksSampled = 0;
@@ -68,13 +62,10 @@ public abstract class BiomeProvider
 
         LOGGER.info("Sampling " + sizeChunks * sizeChunks + " chunks for biome test...");
 
-        for (int x = -sizeChunks / 2; x < sizeChunks / 2; x++)
-        {
-            for (int z = -sizeChunks / 2; z < sizeChunks / 2; z++)
-            {
-                final int pctg = (int) (chunksSampled / (float)(sizeChunks * sizeChunks) * 100);
-                if (pctg != lastReport)
-                {
+        for (int x = -sizeChunks / 2; x < sizeChunks / 2; x++) {
+            for (int z = -sizeChunks / 2; z < sizeChunks / 2; z++) {
+                final int pctg = (int) (chunksSampled / (float) (sizeChunks * sizeChunks) * 100);
+                if (pctg != lastReport) {
                     LOGGER.info("{}% complete...", pctg);
                     lastReport = pctg;
                 }
@@ -90,16 +81,12 @@ public abstract class BiomeProvider
         LOGGER.info("    Average temperature: {}", String.format("%.2f", tempAcc / (float) (sizeChunks * sizeChunks)));
         LOGGER.info("    Average humidity: {}", String.format("%.2f", humAcc / (float) (sizeChunks * sizeChunks)));
         LOGGER.info("    Biome distribution:");
-        for (final Biome biome : Registries.BIOMES)
-        {
+        for (final Biome biome : Registries.BIOMES) {
             float pctg;
-            if (biomeOccurrenceMap.containsKey(biome))
-            {
+            if (biomeOccurrenceMap.containsKey(biome)) {
                 pctg = biomeOccurrenceMap.getInt(biome) / (float) (sizeChunks * sizeChunks);
                 pctg *= 100;
-            }
-            else
-            {
+            } else {
                 pctg = 0.0f;
             }
             LOGGER.info("        {}: {}%", Registries.BIOMES.getKey(biome), String.format("%.2f", pctg));
